﻿Imports System.IO
Imports Tea_Timer_Professional.DataSet1
Public Class frmHauptform
    Private Temperatur As Integer = 100
    Private Sekunden As Integer = 0
    Private Minuten As Integer = 0
    Private _DataFile As New FileInfo("Tee.Xml")
    'Private _DataFile1 As New FileInfo("Abkuehlzeiten.Xml")
    'Form Close und Load Event
    Private Sub frmHauptform_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        lblTemperatur.Text = Temperatur.ToString
        lblZiehzeitSekunden.Text = Sekunden.ToString("00")
        lblZiehzeitMinuten.Text = Minuten.ToString("00")
        DataSet1.ReadXml(_DataFile.FullName)
        'DataSet1.ReadXml(_DataFile1.FullName)
    End Sub
    Private Sub frmHauptform_FormClosed(sender As Object, e As FormClosedEventArgs) Handles MyBase.FormClosed
        DataSet1.WriteXml(_DataFile.FullName)
    End Sub
    'Klick Events - Buttons
    Private Sub btnTemperaturMinus_Click(sender As Object, e As EventArgs) Handles btnTemperaturMinus.Click
        'verringert Temperatur um 5°
        Temperaturaendern(-5)
    End Sub
    Private Sub btnTemperaturPlus_Click(sender As Object, e As EventArgs) Handles btnTemperaturPlus.Click
        'erhöht Temperatur um 5°
        Temperaturaendern(5)
    End Sub
    Private Sub btnZiehzeitPlus_Click(sender As Object, e As EventArgs) Handles btnZiehzeitPlus.Click
        'Ziehzeit erhöhen
        Ziehzeitaendern("+")
    End Sub
    Private Sub btnZiehzeitMinus_Click(sender As Object, e As EventArgs) Handles btnZiehzeitMinus.Click
        'Ziehzeit verkürzen
        Ziehzeitaendern("-")
    End Sub
    Private Sub btnstart_Click(sender As Object, e As EventArgs) Handles btnstart.Click
        'Sub zum starten des Timers
        'prüfen ob Ton agespielt werden soll
        Dim Sound As Boolean = My.Settings.Sound
        'Ziehzeit in Sekunden umrechnen
        Dim Ziehzeit As Integer = Sekunden + Minuten * 60
        'wenn keine Zeit vergeben wurde, abbruch der Sub
        If Ziehzeit = 0 Then
            MessageBox.Show("Bitte Ziehzeit eingeben.")
            Exit Sub
        End If
        'Temperaturzeit in Sekunden umrechnen
        Dim AbkuehlSekunden As Integer = Integer.Parse(lblAbkuehlzeitSekunden.Text)
        Dim AbkuehlMinuten As Integer = Integer.Parse(lblAbkuehlzeitMinuten.Text)
        Dim Abkuehlzeit As Integer = AbkuehlSekunden + AbkuehlMinuten * 60
        'aktuelle Form ausblenden
        Me.Hide()
        'Wenn Abkühlzeit größer als 0, dann zeigen der Form fTimer Abkühlen
        If Abkuehlzeit > 0 Then
            Dim frmAbkuehlzeit As New frmTimer
            With frmAbkuehlzeit
                .SetSound = Sound
                .SetZeit = Abkuehlzeit
                .SetZiehen = False
                .ShowDialog(Me)
            End With
        End If
        'zeigen der Form fTimer für die Ziehzeit
        Dim frmZiehzeit As New frmTimer
        With frmZiehzeit
            .SetSound = Sound
            .SetZeit = Ziehzeit
            .SetZiehen = True
            .ShowDialog(Me)
        End With
        Me.Show()
    End Sub
    Private Sub btnbeenden_Click(sender As Object, e As EventArgs) Handles btnbeenden.Click
        'Sub zum beenden des Programms
        Me.Close()
    End Sub
    Private Sub btnloeschen_Click_1(sender As Object, e As EventArgs) Handles btnloeschen.Click
        'Sub zum löschen aus dem Dataset
        DTTeesortenBindingSource.RemoveCurrent()
    End Sub
    Private Sub btnNeu_Click(sender As Object, e As EventArgs) Handles btnNeu.Click
        'Sub zum Eintragen eines neuen Tees
        DTTeesortenBindingSource.EditNew(Of frmNeu)
    End Sub
    Private Sub DTTeesortenDataGridView_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles DTTeesortenDataGridView.CellContentClick
        Dim Spalte = DirectCast(DirectCast(DTTeesortenBindingSource.Current, DataRowView).Row, DTTeesortenRow)
        Temperatur = Spalte.Temperatur
        Sekunden = Spalte.Sekunden
        Minuten = Spalte.Minuten
        lblTemperatur.Text = Temperatur.ToString
        lblZiehzeitSekunden.Text = Sekunden.ToString("00")
        lblZiehzeitMinuten.Text = Minuten.ToString("00")
        TemperaturinZeit()
    End Sub
    Private Sub DTTeesortenDataGridView_CellContentDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DTTeesortenDataGridView.CellContentDoubleClick
        'Sub zum bearbeiten eines Tees
        DTTeesortenBindingSource.EditCurrent(Of frmNeu)
    End Sub
    'Klick Events - MenuStrip1
    Private Sub BeendenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles BeendenToolStripMenuItem.Click
        Me.Close()
    End Sub
    Private Sub EinstellungenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles EinstellungenToolStripMenuItem.Click
        Dim frmEinstellungen As New frmEinstellungen
        frmEinstellungen.Show(Me)
    End Sub
    'Subs und Funktionen
    Private Sub Temperaturaendern(Grad As Integer)
        'Sub zum ändern der Temperatur
        Temperatur = Temperatur + Grad
        If Temperatur > 100 Then
            Temperatur = 100
            Exit Sub
        End If
        If Temperatur < 60 Then
            Temperatur = 60
            Exit Sub
        End If
        lblTemperatur.Text = Temperatur.ToString
        TemperaturinZeit()
    End Sub
    Private Sub Ziehzeitaendern(op As String)
        'Intervall aus den Einstellungen lesen
        Dim Intervall As Integer = My.Settings.Zeitintervall
        If op = "+" Then
            'Sekunden erhöhen
            Sekunden = Sekunden + Intervall
            'wenn Sekunden >= 60, dann Sekunden -60 und Minuten +1
            If Sekunden >= 60 Then
                Sekunden = Sekunden - 60
                Minuten = Minuten + 1
            End If
        Else
            'Sekunden verringern
            'Abbruch, wenn Minuten und Sekunden auf 0 stehen
            If Minuten = 0 AndAlso Sekunden = 0 Then Exit Sub
            Sekunden = Sekunden - Intervall
            'wenn Sekunden < 0, dann Sekunden +60 und Minuten -1
            If Sekunden < 0 Then
                Sekunden = Sekunden + 60
                Minuten = Minuten - 1
            End If
        End If
        lblZiehzeitMinuten.Text = Minuten.ToString("00")
        lblZiehzeitSekunden.Text = Sekunden.ToString("00")
    End Sub
    Private Sub TemperaturinZeit()
        'Sub zum ändern der Abkühlzeit je nach Temperatur
        Dim Zeit As Integer
        Select Case Temperatur
            Case = 100 : Zeit = 0
            Case = 95 : Zeit = (My.Settings.Temp95)
            Case = 90 : Zeit = (My.Settings.Temp90)
            Case = 85 : Zeit = (My.Settings.Temp85)
            Case = 80 : Zeit = (My.Settings.Temp80)
            Case = 75 : Zeit = (My.Settings.Temp75)
            Case = 70 : Zeit = (My.Settings.Temp70)
            Case = 65 : Zeit = (My.Settings.Temp65)
            Case 60 : Zeit = (My.Settings.Temp60)
        End Select
        lblAbkuehlzeitMinuten.Text = (Zeit \ 60).ToString("00")
        lblAbkuehlzeitSekunden.Text = (Zeit Mod 60).ToString("00")
    End Sub
End Class
